clear all
%% Get the data
%Choose 2 excelfiles containing the data of the eggs that you want
%measurement from
[file, path] = uigetfile('*.mat','Select ?data file');


load(file);


%Using importfunction
%[T,RH,t,pos,ox,data,comments,Dia,c,total_h] = importfunc(strcat(dataName{1}),strcat(envName{1}));
%%
%use a standard volume and assume it to be the same for alla eggs. isch
%use it to get the area over time like in last one. Since Evap will be the
%same as before we will know volume if we know volume at start.


R = 8.31446261815324; % [Nm/(mol*K)]
%meanA = 0.0071;
%stdA = 3.1835e-04;
N = sqrt(59);
meanD = - 9.9128e-09; %Multiply this with 1.8 (or maybe a bit less) if we want to use Seymour & Visschendijk

stdD = 1.8576e-09; %[m^2/s]
D = [meanD+stdD;meanD;meanD-stdD]; %[m^2/s]
Derr = stdD/(N*meanD);

meanl = 3.9811e-04; %[m]
stdl = 3.6486e-05; %[m]
l = [meanl + stdl; meanl; meanl - stdl]; %[m]
lerr = stdl/(N*meanl);

V = 3.3258e-07; %[m^3]
Vstd = 1.4504e-07; %[m^3]
Verr = Vstd/(V*N);

V = [V - Vstd,V,V + Vstd]; %[m^3]

dayChangeVol = 5.0474e-07; %[m^3]
dayChangeVolstd = 8.0708e-08;%[m^3]
dayChangeVolerr = dayChangeVolstd/(dayChangeVol*N);

dayChangeVol = [dayChangeVol-dayChangeVolstd dayChangeVol dayChangeVol+dayChangeVolstd]; %[m^3]
 
Vol_time = V + data.t/3600/24.*dayChangeVol; %[m^3]

%%

timesteps = length(Vol_time);
places = [1 round(timesteps/4) round(timesteps/2) round(3*timesteps/4) timesteps];
Abase = areaFromVol(data.Dia/2*ones(1,3),data.c*ones(1,3), Vol_time(places,:)','ellipsoid');

Abaseerr = Verr+(places*dayChangeVolerr/3600/24);

x = data.t(places);

%% Calculate the chosen eggs
%Precreates empty arrays to be make in the loop later on

%interpolate the area values linearly to make an area vector the same
%size as the oxygen
Ausehigh = interp1(x, Abase(3,:), linspace(data.t(1),data.t(end),length(data.ox))');
Ausemed = interp1(x, Abase(2,:), linspace(data.t(1),data.t(end),length(data.ox))');
AuseLow = interp1(x, Abase(1,:), linspace(data.t(1),data.t(end),length(data.ox))');

Auseerr = interp1(x, Abaseerr, linspace(data.t(1),data.t(end),length(data.ox))');
%concatenate the different areas into a single vector 
%with low mean and high values
Ause = [AuseLow,Ausemed,Ausehigh];

%calculate oxygen flow and total oxygen
influx = D'.*Ause.*(data.ox-0.2095.*((101325-0.7*p_Arden(22)*100)./(R.*(273.15+data.T))))./l'; %[mol/s]

influxerr = sqrt(Derr^2+Auseerr.^2+lerr.^2);
total_transport = cumtrapz(influx).*data.t(data.hotplace)./length(influx); %[mol]
tx = linspace(0,data.t(end)/3600/24,length(data.ox))';

%%
disp(strcat([' Low D: ';'mean D: ';'High D: '] , string(D) , [' m^2/s';' m^2/s';' m^2/s']))
disp(strcat([' Low Area: '; 'mean Area: '; 'High Area: '], string(Abase(:,1)), [' m^3';' m^3';' m^3']))
disp(strcat([' Low Volume: '; 'mean Volume: '; 'High Volume: '], string(V'), [' m^3';' m^3';' m^3'],[',   Low Area: '; ',  mean Area: '; ',  High Area: '], string(Abase(:,1)), [' m^2';' m^2';' m^2']))
figure
uncflux = [influx(:,2).*(1-influxerr),influx(:,2),influx(:,2).*(1+influxerr)];
size(uncflux)   
uncPlot(tx,uncflux','red')
xlabel 'Time [days]'
ylabel 'Oxygen flux [mol/s]'
title(strcat('Oxygen flux with error ', file))