%                   ----------[Egg diffusion constants Calculator]---------------------
%Note that all variables in the workspace are removed before execution.
%Save all that you need.
%% Make Time and load data

clear all
load('EggOxygenSlope')
load('EggDataSlope')
t = linspace(0, 31278, 31279);

%%
%Areas of eggshell between aircell and ambient
%EggAreas = pi*Eggr.*(c.*asin(1)-(c-h).*sqrt(1-((c-h)./c).^2)-c.*asin((c-h)./c)); %[m^2]
EggAreas = zeros(length(Eggr),1);
for i = 1:length(Eggr)
         fun = @(y) 2*pi*Eggr(i)./c(i).*sqrt(c(i).^2-(c(i).^2-Eggr(i).^2)./c(i).^2.*y.^2);
         EggAreas(i) = integral(fun,c(i)-h(i),c(i));
end


%% Do the fitting

%creates matrices for all the values to be saved in the coming loop
EggsToFit = 1:9;
Fcell = {}; 
D = zeros(9,7);
sse = zeros(9,7);
r2 = zeros(9,7);
%Loop through all the Eggs
for i  = 1:9
    %Loop through all the repeats in the current egg
    for j = 1:lengths(i)
        %Only fit if there is data
        if Egg(2,j+(i-1)*7) ~= 0
            %Makes a temporary matrix of the current egg
            EggT(:,i*7+j-7) = Egg(:,i*7+j-7);%#ok
            %Make the Fits
            [Fcell{i,j} Gcell{i,j} Ocell{i,j}] = fit(t(abs(EggT(1:end,i*7+j-7)) > 0)',EggT(abs(EggT(1:end,i*7+j-7)) > 0,i*7+j-7), 'exp1'); %#ok

            
            %saves some interesting data from the fitting objects
            D(i,j) = Fcell{i,j}.b.*ShellThick.*EggVolumes(i)./EggAreas(i);
            
            sse(i,j) = Gcell{i,j}.sse;
            r2(i,j) = Gcell{i,j}.rsquare;
            rmse(i,j) = Gcell{i,j}.rmse;
        end
    end
    
end

%% plot em all

%This loop plots every single fit and measured data in the same plot. It
%also plots the residuals for every measurement
    
for i  = 1:9 %which egg?/eggs

    %Loop through all the repeats in the current egg
              %hold on
              
    for j = 1:lengths(i) %Which repeat/repeats
           %figure
           figure
          %plot(i*7+j-7,-DAs(i,j),'o')

%            %plots the fit
           plot(Fcell{i,j})
           %Puts the following plot in the same window
           hold on     
           %plots the measured data
           plot(t(abs(Egg(1:end,i*7+j-7)) > 0)',Egg(abs(Egg(1:end,i*7+j-7)) > 0,i*7+j-7))
           legend ('Fitted Curve','Measured Data');
           title (strcat('Egg', int2str(i), ' slope: ', int2str(j)))

%            %Saves the current plot in the current folder. Keep this
%            %commented out untill u really want to save it
%            %saveas (gcf, strcat('FitEggnr', int2str(i),'_CalcH'), 'bmp')
%            
%            figure
%            %plots the residuals
%            plot (Fcell{i,j},t(abs(Egg(1:end,i*7+j-7)) > 0)',Egg(abs(Egg(1:end,i*7+j-7)) > 0,i*7+j-7), 'Residuals')
            %title ({'Egg ' int2str(i) ' experiment' int2str(j) ' Residuals'})
%             %Saves the current plot in the current folder. Keep this
%            %commented out untill u really want to save it
          xlabel 'Time [s]'
          ylabel 'Concentration difference [mol/m^3]'

        %  saveas (gcf, strcat('Egg', int2str(i),'O20',int2str(j)), 'epsc')
    end
    
%title ('Oxygen concentration difference over the eggshell after changing outside gas all eggs')


end

%% Calculate the effect of differing h-value on Eggs that are very different
% l = 400;
% EggI = [1 2];
% axis1 = linspace(-70,0,l);
% axis2 = linspace(1,l,l);
% CalcR = Eggr(EggI);
% CalcC = c(EggI);
% 
% base1 = EggAreas(EggI)./EggVolumes(EggI);
% base2 = EggAreas(EggI)./EggVolumes(EggI);
% dcu = zeros(l,length(EggI));
% dcd = zeros(l,length(EggI));
% for k = 1:l
%     htemp1 = h(EggI)+h(EggI)*0.01*k; 
%     dcu(k,:) = ((pi.*CalcR.*(CalcC.*asin(1)-(CalcC-htemp1).*sqrt(1-((CalcC-htemp1)./CalcC).^2)-CalcC.*asin((CalcC-htemp1)./CalcC)))./(pi./3.*(htemp1.*a./c_shape).^2.*(3.*CalcC-htemp1)))./base1;
%     htemp2 = h(EggI)-h(EggI)*0.7/l*(l-k);
%     dcd(k,:) = ((pi.*CalcR.*(CalcC.*asin(1)-(CalcC-htemp2).*sqrt(1-((CalcC-htemp2)./CalcC).^2)-CalcC.*asin((CalcC-htemp2)./CalcC)))./(pi./3.*(htemp2.*a./c_shape).^2.*(3.*CalcC-htemp2)))./base1;  
% end
% offset = [1.9621 1.5044];
% for k = 1:length(EggI)
% figure
% plot([axis1 axis2], [dcd(:,k); dcu(:,k)])
% hold on
% plot([axis1 axis2], linspace(1/offset(k),1/offset(k),l*2),'k--');
% title(strcat('A/V with differing h in egg .', int2str(k)))
% xlabel('h going from -70% to +400%')
% legend('Frraction h difference', 'h required to get d-value similar to the rest')
% end
% 
%% Calculate the effect of differing Rvalues on Eggs that are outlieing
% l = 115;
% EggI = [1 2];
% axis1 = linspace(-70,0,l);
% axis2 = linspace(1,l,l);
% CalcR = Eggr(EggI);
% CalcC = c(EggI);
% 
% base1 = EggAreas(EggI)./EggVolumes(EggI);
% base2 = EggAreas(EggI)./EggVolumes(EggI);
% dcu = zeros(l,length(EggI));
% dcd = zeros(l,length(EggI));
% 
% for k = 1:l
%     ACrtemp1 = ACr(EggI)+ACr(EggI).*0.01.*k; 
%     htemp1 = c(EggI)-c(EggI).*sqrt(1-(ACrtemp1./Eggr(EggI)).^2); %[m]
%    
%     dcu(k,:) = ((pi.*CalcR.*(CalcC.*asin(1)-(CalcC-htemp1).*sqrt(1-((CalcC-htemp1)./CalcC).^2)-CalcC.*asin((CalcC-htemp1)./CalcC)))./(pi./3.*(htemp1.*a./c_shape).^2.*(3.*CalcC-htemp1)))./base1;
%     ACrtemp2 = ACr(EggI)-ACr(EggI).*0.7/l.*(l-k); 
%     htemp2 = c(EggI)-c(EggI).*sqrt(1-(ACrtemp2./Eggr(EggI)).^2); %[m]
%     dcd(k,:) = ((pi.*CalcR.*(CalcC.*asin(1)-(CalcC-htemp2).*sqrt(1-((CalcC-htemp2)./CalcC).^2)-CalcC.*asin((CalcC-htemp2)./CalcC)))./(pi./3.*(htemp2.*a./c_shape).^2.*(3.*CalcC-htemp2)))./base1;  
% end
% offset = [1.9621 1.5044];
% for k = 1:length(EggI)
% figure
% plot([axis1 axis2], [dcd(:,k); dcu(:,k)])
% hold on
% plot([axis1 axis2], linspace(1/offset(k),1/offset(k),l*2),'k--');
% title(strcat('A/V with differing aircell radius in egg .', int2str(k)))
% xlabel('aircell radius going from -70% to +115%')
% legend('Frraction h difference', 'aircell radius required to get d-value similar to the rest')
% end


%% Get statistical data
Goods = [1:6 9];



Dmean = mean(mean(D(D<0)));
Dstd = std(D(D<0));

ssemean = mean(mean(sse(sse>0)));
ssestd = std(sse(sse>0));

r2mean = mean(mean(r2(r2>0)));
r2std = std(r2(r2>0));

rmsemean = mean(mean(rmse(rmse>0)));
rmsestd = std(rmse(rmse>0));


%% Plot the Ds as a function of the different days
%Create matrices for the values
meansD = zeros(9,1);
SED = zeros(9,1);
meansT = zeros(9,1);
SET = zeros(9,1);
%loop from 1 to 9 and put in the values into the matrices for every egg
for i = 1:9
    currowD = nonzeros(D(i,:));
    currowT = nonzeros(Ts(i,:));
    meansD(i) = mean(currowD);
    meansT(i) = mean(currowT);
    SED(i) = std(currowD)/sqrt(numel(currowD));
    SET(i) = std(currowT)/sqrt(numel(currowT));
end
%% Plot some different data as function of days or other data

%--------------------------
figure
errorbar([1,2,4,8,11,4,5,2,5], meansD(1:end),SED(1:end),'r.')
title('Errorbar of the means and standard errors the different days')
text([1,2,4,8,11,4,5,2,5], meansD(1:end),{'Day 1 Egg 1','Day 2 Egg 2', 'Day 4 Egg 3', 'Day 9 Egg 6', 'Day 11 Egg 8', 'Day 4 Egg 11', 'Day 5 Egg 11', 'Day 2 Egg 15', 'Day 5 Egg 16'})
xlabel('[Days]')
ylabel('[m^2/s]')
%hold on
%scatter(2,-12*10^-9,13000)
%saveas (gcf, 'DvsDays_m2_CalcH_12-08', 'bmp')

 
%--------------------------
figure
plot([1,2,4,8,11,4,5,2,5], EggVolumes,'ko')
title('The different volumes the different days [mm^3]')
ylabel('[mm^3]')
xlabel('[Days]')
%saveas (gcf, 'VvsDays_m2_12-08', 'bmp')

%--------------------------
figure
errorbar(EggVolumes,meansD,SED,'ko')
title('Errorbar of the means vs the volumes')
text(EggVolumes,meansD,{'Day 1', 'Day 2', 'Day 4', 'Day 9', 'Day 11', 'Day 5', 'Day 5,2', 'Day 2,2', 'Day 5,3'})
ylabel('[m^2/s]')
xlabel('[m^3]')
%saveas (gcf, 'DvsV_m2_CalcH_12-08', 'bmp')

%--------------------------
% figure
% plot(meansT,meansD,'o')
% title('Means in D vs means in T')
% text(meansT,meansD,{'Day 1', 'Day 2', 'Day 4', 'Day 9', 'Day 11', 'Day 5', 'Day 5', 'Day 2', 'Day 5'})
% ylabel('[m^2/s]')
% xlabel('[C]')
%saveas (gcf, 'DvsT_m2', 'bmp')
%%
%meansD = meansD*10^4; %[cm^2/s]
% SED = SED*10^4; %[[cm^2/s]
%--------------------------
% figure
% errorbar([1,2,4,8,11,5,5,2,5], meansD,SED,'r.')
% title('Errorbar of the means and standard errors the different days')
% text([1,2,4,8,11,5,5,2,5], meansD,{'Day 1', 'Day 2', 'Day 4', 'Day 9', 'Day 11', 'Day 5', 'Day 5', 'Day 2', 'Day 5'})
% xlabel('[Days]')
% ylabel('[cm^2/s]')
% %saveas (gcf, 'DvsDays_cm2_CalcH', 'bmp')
% 
% 
%--------------------------
% figure
% errorbar(EggVolumes,meansD,SED,'ko')
% title('Errorbar of the means vs the volumes')
% text(EggVolumes,meansD,{'Day 1', 'Day 2', 'Day 4', 'Day 9', 'Day 11', 'Day 5', 'Day 5', 'Day 2', 'Day 5'})
% ylabel('[cm^2/s]')
% xlabel('[m^3]')
% %saveas (gcf, 'DvsV_cm2_CalcH', 'bmp')



%--------------------------
% figure
% plot(meansT,meansD,'o')
% title('Means in D vs means in T')
% text(meansT,meansD,{'Day 1', 'Day 2', 'Day 4', 'Day 9', 'Day 11', 'Day 5', 'Day 5', 'Day 2', 'Day 5'})
% ylabel('[cm^2/s]')
% xlabel('[C]')
% %saveas (gcf, 'DvsT_cm2', 'bmp')


%%
%Old Volumes and araes in case one wants to review them
% EggVolumesEmmaModel = [906 1275 960 2197 3180 755].*10^-9; %[m^3] Emmas model of aircell geometry
% EggVolumesPatModMeasH  = [853 1379 869 2417 3871 800].*10^-9; %[m^3] Patriks model of aircell geometry with measured h
% %EggVolumesWringSide = [432 578 521 991 1328 346].*10^-9; %[m^3] Patriks model of aircell geometry with calculated h
% EggVolumes = [325 434 391 744 997 260 387 400 436].*10^-9; %[m^3]Pat model Calc h corect frac
% EggVolumesPatModCalcHBig = [1680 2224 2009 2397 3837 793].*10^-9; %[m^3]Pat model pat calc h times 2
% 
% EggAreasOld = [370 450 390 620 780 330].*10^-6; %[m^2] Calculated with emmas model
% EggAreasWrongSide = [203 280 198 428 606 186].*10^-6; %[m^2] Calculated with patriks model
% EggAreasPatModel = [230 321 227 488 688 213].*10^-6; %[m^2] Calculated with patriks model on the right side of the egg
% EggAreas = [91 116 107 174 219 79 105 108 116]*10^-6; %[m^2] Calculated with patriks model on the right side of the egg Calculated height
% 

